/************************************************/
/* uPD7210 GPIB library				*/
/*----------------------------------------------*/
/*						*/
/*						*/
/************************************************/
/* (note)
  ñ˻Ȥޤ
  ǥХϡDEVICE_NAME ǡܡɣΤߤΥݡȤǤ
  ǥߥϡCR+LF with EOIΤߥݡȤǤ
  顼夤ʬޤ

 $Id: libgpib.c,v 1.2 2002/10/14 04:35:11 hirohito Exp $
*/

/***** Feature test switches ************************************************/

/***** System headers *******************************************************/
#include <unistd.h>
#include <fcntl.h>
#include <string.h>


/***** Local headers ********************************************************/
#include "upd7210.h"


/***** Constat values *******************************************************/
#define DEVICE_NAME "/dev/gpib0"


/***** Macros ***************************************************************/


/***** Typedefs *************************************************************/


/***** Function prototypes **************************************************/

/***** Local variables ******************************************************/

/***** Global variables *****************************************************/
int _GPIB_FD;


/***** Local functions ******************************************************/


/***** Global functions *****************************************************/
/*==========================================================================
 * initalize
 *--------------------------------------------------------------------------
 * arg: none
 * ret: int	Negative value if error occurred.
 *--------------------------------------------------------------------------
 * 
 * 
*/
int  GPIB_init()
{
    return _GPIB_FD = open( DEVICE_NAME, O_RDWR );
}



/*==========================================================================
 * end
 *--------------------------------------------------------------------------
 * arg: none
 * ret: int	Negative value if error occurred.
 *--------------------------------------------------------------------------
 * 
 * 
*/
int  GPIB_close()
{
    return close( _GPIB_FD );
}



/*==========================================================================
 * write (talk)
 *--------------------------------------------------------------------------
 * arg: addr	listener address
 *	msg	message string
 * ret: int	Negative value if error occurred.
 *--------------------------------------------------------------------------
 * 
 * 
*/
int  GPIB_write( int addr, const char *msg )
{
    GPIB_PACKET gpkt;
    gpkt.listener[0] = addr;
    gpkt.listener[1] = -1;
    gpkt.delimiter = GPIB_DLM_CR|GPIB_DLM_LF|GPIB_DLM_EOI;
    gpkt.message = (char*)msg;
    gpkt.msglen = strlen( gpkt.message );
    if( ioctl( _GPIB_FD, GPIB_TALK, &gpkt ) < 0 ) return GPIB_EUNKNOWN;
    return gpkt.errno;
}



/*==========================================================================
 * read (listen)
 *--------------------------------------------------------------------------
 * arg: addr	talker address
 *	buf	message buffer
 *	len	buffer size
 * ret: int	Negative value if error occurred.
 *--------------------------------------------------------------------------
 * 
 * 
*/
int  GPIB_read( int addr, char *buf, int len )
{
    GPIB_PACKET gpkt;
    gpkt.talker = addr;
    gpkt.delimiter = GPIB_DLM_CR|GPIB_DLM_LF|GPIB_DLM_EOI;
    gpkt.message = buf;
    gpkt.msglen = len;
    if( ioctl( _GPIB_FD, GPIB_LISTEN, &gpkt ) < 0 ) return GPIB_EUNKNOWN;
    if( gpkt.msglen < len ) buf[gpkt.msglen] = '\0';
    return gpkt.errno;
}



/*==========================================================================
 * get status
 *--------------------------------------------------------------------------
 * arg: addr	gpib address
 * ret: int	status.
 *--------------------------------------------------------------------------
 * 
 * 
*/
int  GPIB_get_status( int addr )
{
    GPIB_PACKET gpkt;
    gpkt.listener[0] = addr;
    gpkt.listener[1] = -1;
    ioctl( _GPIB_FD, GPIB_SP, &gpkt );
    return gpkt.listener[0];
}
