/************************************************/
/* uPD7210 driver				*/
/*----------------------------------------------*/
/*						*/
/* This file is completely in public domain.	*/
/************************************************/
/* (note)
  flags: bit0 - Talk only (not tested)
	 bit1 - Listen only (not tested)
	 bit2 -/Controler
  options:
	 GPIB_PC9801_29		NEC PC-9801-29 or 29N
	 GPIB_CONTEC_PC		CONTEC GP-IB(PC)
	 GPIB_CONTEC_PCL	CONTEC GP-IB(PC)L
	 GPIB_CONTEC_PCIL	CONTEC GP-IB(PCI)L

 $Id: upd7210_var.h,v 1.3 2003/11/17 14:11:02 hirohito Exp $
*/


/***** Feature test switches ************************************************/
#ifndef	__UPD7210_VAR_H_proto_
#define	__UPD7210_VAR_H_proto_


/***** System headers *******************************************************/
/***** Local headers ********************************************************/
#include "gpib.h"


/***** Depend on expansion board ********************************************/
#if defined(GPIB_PC9801_29)
/* (note)
   å, T/R2, T/R3ϡŬ˽񤤤ɡƥȤƤäϰϤǤ
   ޤưƤߤ
   äȤ⡢å˴ؤƤϡ⤷ְäƤƤ⡢ǽФʤưϤȻפɡ
*/
  #define T1679		0x08	/* ܻ (clock 8MHz) */
  #define TRM01		0x30	/* T/R2=CIC, T/R3=PE */
  #define USED_IO_SPACE	15

#elif defined(GPIB_CONTEC_PC)
/* (note)
   ĤϡåISAå򤽤Τޤ޻ȤäƤ롣
   äԤꥪСå͡
*/
  #define T1679		0x08	/* ܻ (clock 8MHz) */
  #define TRM01		0x30	/* T/R2=CIC, T/R3=PE */
  #define USED_IO_SPACE	2	/* ȴƤ뤷ɤФ */

  /* uPD7210 Read register */
  #define data_in(s)		bus_space_read_1((s)->bst, (s)->bsh, 0x0000 )
  #define interrupt_status1(s)	bus_space_read_1((s)->bst, (s)->bsh, 0x0400 )
  #define interrupt_status2(s)	bus_space_read_1((s)->bst, (s)->bsh, 0x0800 )
  #define serial_poll_status(s)	bus_space_read_1((s)->bst, (s)->bsh, 0x0c00 )
  #define address_status(s)	bus_space_read_1((s)->bst, (s)->bsh, 0x1000 )
  #define command_pass_through(s) bus_space_read_1((s)->bst, (s)->bsh, 0x1400 )
  #define address0(s)		bus_space_read_1((s)->bst, (s)->bsh, 0x1800 )
  #define address1(s)		bus_space_read_1((s)->bst, (s)->bsh, 0x1c00 )

  /* uPD7210 Write register */
  #define byte_out(s,d)		bus_space_write_1((s)->bst, (s)->bsh, 0x0000, (d))
  #define interrupt_mask1(s,d)	bus_space_write_1((s)->bst, (s)->bsh, 0x0400, (d))
  #define interrupt_mask2(s,d)	bus_space_write_1((s)->bst, (s)->bsh, 0x0800, (d))
  #define serial_poll_mode(s,d)	bus_space_write_1((s)->bst, (s)->bsh, 0x0c00, (d))
  #define address_mode(s,d)	bus_space_write_1((s)->bst, (s)->bsh, 0x1000, (d))
  #define auxiliary_mode(s,d)	bus_space_write_1((s)->bst, (s)->bsh, 0x1400, (d))
  #define address(s,d)		bus_space_write_1((s)->bst, (s)->bsh, 0x1800, (d))
  #define end_of_string(s,d)	bus_space_write_1((s)->bst, (s)->bsh, 0x1c00, (d))

#elif defined(GPIB_CONTEC_PCL) || defined(GPIB_CONTEC_PCIL)
/* (note)
   å, T/R2, T/R3Ȥɡޤ3state driverѤƤ뤫
   ְ㤤ʤȻפ
*/
  #define T1679		0x08	/* ܻ (clock 8MHz) */
  #define TRM01		0x30	/* T/R2=CIC, T/R3=PE */
  #define USED_IO_SPACE	32

#else
  #error "Please specify board name in config file."
#endif
#ifndef T1679		/* ܻ (clock 8MHz) */
  #define T1679		0x08
#endif
#ifndef TRM01		/* T/R2=CIC, T/R3=PE for 3state driver */
  #define TRM01		0x30
#endif
#ifndef MODE_T1		/* B2˥åȤ⡼ɡʹ®=0x04/®=0x00 */
  #define MODE_T1	0x04
#endif
#ifndef MODE_INTLVL	/* INTüҤΥƥ֥٥ /INT=0x08, INT=0x00 */
  #define MODE_INTLVL	0x00
#endif
#ifndef USED_IO_SPACE
  #define USED_IO_SPACE	32
#endif


/***** Constat values *******************************************************/
#define DRIVER_NAME "gpib"
#define CDEV_MAJOR 210

#define MY_ADDRESS	30	/* my gpib address. less than 31 */
#define TIMEOUT		5	/* sec */
#define DELIMITER	GPIB_DLM_CR+GPIB_DLM_LF+GPIB_DLM_EOI
#ifndef GPIB_BUFFERSIZE
  #define GPIB_BUFFERSIZE 1024	/* send/receive buffer size */
#endif

/* uPD7210 Auxiliary Command */
#define IMMEDIATE_EXECUTE_PON		0x00
#define CHIP_RESET			0x02
#define FINISH_HANDSHAKE		0x03
#define TRIGGER				0x04
#define CLEAR_RETURN_TO_LOCAL		0x05
#define SET_RETURN_TO_LOCAL		0x0d
#define SEND_EOI			0x06
#define NON_VALID			0x07
#define VALID				0x0f
#define SET_PARALLEL_POLL_FLAG		0x01
#define CLEAR_PARALLEL_POLL_FLAG	0x09
#define GO_TO_STANDBY			0x10
#define TAKE_CONTROL_ASYNCHRONOUSLY	0x11
#define TAKE_CONTROL_SYNCHRONOUSLY	0x12
#define TAKE_CONTROL_SYNCHRONOUSLY_ON_END 0x1a
#define LISTEN				0x13
#define LISTEN_WITH_CONTINUOUS_MODE	0x1b
#define LOCAL_UNLISTEN			0x1c
#define EXECUTE_PARALLEL_POLL		0x1d
#define SET_IFC				0x1e
#define CLEAR_IFC			0x16
#define SET_REN				0x1f
#define CLEAR_REN			0x17
#define DISABLE_SYSTEM_CONTROL		0x14

/* inturrupt status resister bit mask */
#define BIT_DI	0x01	/* DI  : DataIn  bit in Interrupt status 1 */
#define BIT_DO	0x02	/* DO  : DataOut bit in Interrupt status 1 */
#define BIT_CO	0x08	/* CO  : Command Out bit in interrupt status 2 */
#define BIT_END	0x10	/* END : EOI status in Interrupt status 1 */
#define BIT_ATN 0x40	/* /ATN: Attention bit in Address Status */

/* GPIB multiline message */
#define DCL	0x14	/* Device Clear */
#define SDC	0x04	/* Select Device Clear */
#define GET	0x08	/* Group Execute Trigger */
#define TCT	0x09	/* Take Control */
#define LLO	0x11	/* Local Lockout */
#define GTL	0x01	/* Go to Local */
#define UNL	0x3f	/* Unlisten */
#define UNT	0x5f	/* Untalk */
#define TAG	0x40	/* Talker Address Group */
#define LAG	0x20	/* Listener Address Group */
#define SPE	0x18	/* Serial Pole Enable */
#define SPD	0x19	/* Serial Pole Disable */
#define PPC	0x05	/* Parallel Poll Configure */
#define PPU	0x15	/* Parallel Poll Unconfigure */
#define PPE	0x60	/* Parallel Poll Enable */
#define PPD	0x70	/* Parallel Poll Disable */


/***** Macros ***************************************************************/
#define FLAGS_TALKONLY(f)	((f)&0x01)
#define FLAGS_LISTENONLY(f)	((f)&0x02)
#define FLAGS_IS_CONTROLLER(f)	(!((f)&0x03))
#define aux_command(p,c)	auxiliary_mode((p),0x1f&(c))

#ifndef data_in
  /* uPD7210 Read register */
  #define data_in(s)		bus_space_read_1((s)->bst, (s)->bsh, 0x00 )
  #define interrupt_status1(s)	bus_space_read_1((s)->bst, (s)->bsh, 0x02 )
  #define interrupt_status2(s)	bus_space_read_1((s)->bst, (s)->bsh, 0x04 )
  #define serial_poll_status(s)	bus_space_read_1((s)->bst, (s)->bsh, 0x06 )
  #define address_status(s)	bus_space_read_1((s)->bst, (s)->bsh, 0x08 )
  #define command_pass_through(s) bus_space_read_1((s)->bst, (s)->bsh, 0x0a )
  #define address0(s)		bus_space_read_1((s)->bst, (s)->bsh, 0x0c )
  #define address1(s)		bus_space_read_1((s)->bst, (s)->bsh, 0x0e )

  /* uPD7210 Write register */
  #define byte_out(s,d)		bus_space_write_1((s)->bst, (s)->bsh, 0x00, (d))
  #define interrupt_mask1(s,d)	bus_space_write_1((s)->bst, (s)->bsh, 0x02, (d))
  #define interrupt_mask2(s,d)	bus_space_write_1((s)->bst, (s)->bsh, 0x04, (d))
  #define serial_poll_mode(s,d)	bus_space_write_1((s)->bst, (s)->bsh, 0x06, (d))
  #define address_mode(s,d)	bus_space_write_1((s)->bst, (s)->bsh, 0x08, (d))
  #define auxiliary_mode(s,d)	bus_space_write_1((s)->bst, (s)->bsh, 0x0a, (d))
  #define address(s,d)		bus_space_write_1((s)->bst, (s)->bsh, 0x0c, (d))
  #define end_of_string(s,d)	bus_space_write_1((s)->bst, (s)->bsh, 0x0e, (d))
#endif


/***** Typedefs *************************************************************/
typedef struct
{
    bus_space_tag_t bst;
    bus_space_handle_t bsh;
    struct resource *res;
    int rid;
#if defined(GPIB_CONTEC_PC)
    bus_space_tag_t bst2;
    bus_space_handle_t bsh2;
    struct resource *res2;
    int rid2;
    int int_mask_ofs;
#endif
    struct resource *irq;
    int irqid;
    void *irqhandle;
    int unit;
    int flags;

    int myaddress;
    int timeout;
    int default_delimiter;
    int delimiter;
    int statusbyte;
    
    int inuse;		/* ե饰 */
    int atn;		/* ATN˥饤 ξ */
    enum
    {	STATE_NONE,
	STATE_TALK, STATE_EOS1, STATE_EOS2,	/*  */
	STATE_LISTEN,				/*  */
	STATE_COMMAND,				/* ޥ */
	STATE_POLL,				/* ݡ */
    } volatile state;

    char buf[GPIB_BUFFERSIZE];	/* Хåե */
    char volatile *pbuf;	/* Хåեݥ */
    char volatile *pbuf_end;
} GPIB_SOFTC;



/***** Global variables *****************************************************/
extern devclass_t gpib_devclass;


/***** Function prototypes **************************************************/
void  gpib_attach_common( GPIB_SOFTC *psc );
void  gpib_interrupt( void * );


/***** Inline functions *****************************************************/


#endif
